Method: instantSnapshots.export

instantSnapshots.export the changed blocks between two instant snapshots to a customer's bucket in the user specified format.

HTTP request

POST https://compute.googleapis.com/compute/beta/projects/{project}/zones/{zone}/instantSnapshots/{instantSnapshot}/export

The URL uses gRPC Transcoding syntax.

Path parameters

Parameters
project

string

Project ID for this request.

zone

string

The name of the zone for this request.

instantSnapshot

string

Name of the instant snapshot to export.

Query parameters

Parameters
requestId

string

An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed.

For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments.

The request ID must be a valid UUID with the exception that zero UUID is not supported (00000000-0000-0000-0000-000000000000).

Request body

The request body contains data with the following structure:

JSON representation
{
  "exportParams": {
    "baseInstantSnapshot": string,
    "bucketName": string,
    "objectName": string,
    "outputType": enum,
    "encryptionKey": {
      "sha256": string,
      "kmsKeyServiceAccount": string,

      
      "rawKey": string,
      "rsaEncryptedKey": string,
      "kmsKeyName": string
      
    }
  }
}
Fields
exportParams

object

Parameters to export the changed blocks.

exportParams.baseInstantSnapshot

string

An optional base instant snapshot that this resource is compared against. If not specified, all blocks of this resource are exported. The base instant snapshot and this resource must be created from the same disk. The base instant snapshot must be created earlier in time than this resource.

Authorization requires the following IAM permission on the specified resource baseInstantSnapshot:

  • compute.instantSnapshots.get
exportParams.bucketName

string

The name of an existing bucket in Cloud Storage where the changed blocks will be stored. The Google Service Account must have read and write access to this bucket. The bucket has to be in the same region as this resource.

exportParams.objectName

string

Name of the output Bigstore object storing the changed blocks. Object name must be less than 1024 bytes in length.

exportParams.outputType

enum

The format of the output file.

exportParams.encryptionKey

object

Encryption key used to encrypt the instant snapshot.

exportParams.encryptionKey.rawKey

string

Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648 base64 to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example:

"rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0=" 

exportParams.encryptionKey.rsaEncryptedKey

string

Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit customer-supplied encryption key to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example:

"rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" 
The key must meet the following requirements before you can provide it to Compute Engine:
  1. The key is wrapped using a RSA public key certificate provided by Google.
  2. After being wrapped, the key must be encoded in RFC 4648 base64 encoding.
Gets the RSA public key certificate provided by Google at:
 https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem

exportParams.encryptionKey.kmsKeyName

string

The name of the encryption key that is stored in Google Cloud KMS. For example:

"kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key 

exportParams.encryptionKey.sha256

string

[Output only] The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.

exportParams.encryptionKey.kmsKeyServiceAccount

string

The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example:

"kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/ 

Response body

If successful, the response body contains data with the following structure:

Represents an Operation resource.

Google Compute Engine has three Operation resources:

You can use an operation resource to manage asynchronous API requests. For more information, read Handling API responses.

Operations can be global, regional or zonal.

  • For global operations, use the globalOperations resource.
  • For regional operations, use the regionOperations resource.
  • For zonal operations, use the zonalOperations resource.

For more information, read Global, Regional, and Zonal Resources.

JSON representation
{
  "kind": string,
  "id": string,
  "creationTimestamp": string,
  "name": string,
  "zone": string,
  "clientOperationId": string,
  "operationType": string,
  "targetLink": string,
  "targetId": string,
  "status": enum,
  "statusMessage": string,
  "user": string,
  "progress": integer,
  "insertTime": string,
  "startTime": string,
  "endTime": string,
  "error": {
    "errors": [
      {
        "code": string,
        "location": string,
        "message": string,
        "errorDetails": [
          {
            "errorInfo": {
              "reason": string,
              "domain": string,
              "metadatas": {
                string: string,
                ...
              }
            },
            "quotaInfo": {
              "metricName": string,
              "limitName": string,
              "dimensions": {
                string: string,
                ...
              },
              "limit": number
            },
            "help": {
              "links": [
                {
                  "description": string,
                  "url": string
                }
              ]
            },
            "localizedMessage": {
              "locale": string,
              "message": string
            }
          }
        ]
      }
    ]
  },
  "warnings": [
    {
      "code": enum,
      "message": string,
      "data": [
        {
          "key": string,
          "value": string
        }
      ]
    }
  ],
  "httpErrorStatusCode": integer,
  "httpErrorMessage": string,
  "selfLink": string,
  "region": string,
  "description": string,
  "operationGroupId": string
}
Fields
kind

string

[Output Only] Type of the resource. Always compute#operation for Operation resources.

id

string (uint64 format)

[Output Only] The unique identifier for the operation. This identifier is defined by the server.

creationTimestamp

string

[Deprecated] This field is deprecated.

name

string

[Output Only] Name of the operation.

zone

string

[Output Only] The URL of the zone where the operation resides. Only applicable when performing per-zone operations.

clientOperationId

string

[Output Only] The value of requestId if you provided it in the request. Not present otherwise.

operationType

string

[Output Only] The type of operation, such as insert, update, or delete, and so on.

targetId

string (uint64 format)

[Output Only] The unique target ID, which identifies a specific incarnation of the target resource.

status

enum

[Output Only] The status of the operation, which can be one of the following: PENDING, RUNNING, or DONE.

statusMessage

string

[Output Only] An optional textual description of the current status of the operation.

user

string

[Output Only] User who requested the operation, for example: user@example.com.

progress

integer

[Output Only] An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses.

insertTime

string

[Output Only] The time that this operation was requested. This value is in RFC3339 text format.

startTime

string

[Output Only] The time that this operation was started by the server. This value is in RFC3339 text format.

endTime

string

[Output Only] The time that this operation was completed. This value is in RFC3339 text format.

error

object

[Output Only] If errors are generated during processing of the operation, this field will be populated.

error.errors[]

object

[Output Only] The array of errors encountered while processing this operation.

error.errors[].code

string

[Output Only] The error type identifier for this error.

error.errors[].location

string

[Output Only] Indicates the field in the request that caused the error. This property is optional.

error.errors[].message

string

[Output Only] An optional, human-readable error message.

error.errors[].errorDetails[]

object

[Output Only] An optional list of messages that contain the error details. There is a set of defined message types to use for providing details.The syntax depends on the error code. For example, QuotaExceededInfo will have details when the error code is QUOTA_EXCEEDED.

error.errors[].errorDetails[].errorInfo

object

error.errors[].errorDetails[].errorInfo.reason

string

The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of [A-Z][A-Z0-9_]+[A-Z0-9], which represents UPPER_SNAKE_CASE.

error.errors[].errorDetails[].errorInfo.domain

string

The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com".

error.errors[].errorDetails[].errorInfo.metadatas

map (key: string, value: string)

Additional structured details about this error.

Keys should match /[a-zA-Z0-9-_]/ and be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than {"instanceLimit": "100/request"}, should be returned as, {"instanceLimitPerRequest": "100"}, if the client exceeds the number of instances that can be created in a single (batch) request.

error.errors[].errorDetails[].quotaInfo

object

error.errors[].errorDetails[].quotaInfo.metricName

string

The Compute Engine quota metric name.

error.errors[].errorDetails[].quotaInfo.limitName

string

The name of the quota limit.

error.errors[].errorDetails[].quotaInfo.dimensions

map (key: string, value: string)

The map holding related quota dimensions.

error.errors[].errorDetails[].quotaInfo.limit

number

Current effective quota limit. The limit's unit depends on the quota type or metric.

error.errors[].errorDetails[].help

object

error.errors[].errorDetails[].help.links[]

object

URL(s) pointing to additional information on handling the current error.

error.errors[].errorDetails[].help.links[].description

string

Describes what the link offers.

error.errors[].errorDetails[].help.links[].url

string

The URL of the link.

error.errors[].errorDetails[].localizedMessage

object

error.errors[].errorDetails[].localizedMessage.locale

string

The locale used following the specification defined at https://www.rfc-editor.org/rfc/bcp/bcp47.txt. Examples are: "en-US", "fr-CH", "es-MX"

error.errors[].errorDetails[].localizedMessage.message

string

The localized error message in the above locale.

warnings[]

object

[Output Only] If warning messages are generated during processing of the operation, this field will be populated.

warnings[].code

enum

[Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no results in the response.

warnings[].message

string

[Output Only] A human-readable description of the warning code.

warnings[].data[]

object

[Output Only] Metadata about this warning in key: value format. For example:

"data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }

warnings[].data[].key

string

[Output Only] A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be scope and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding).

warnings[].data[].value

string

[Output Only] A warning data value corresponding to the key.

httpErrorStatusCode

integer

[Output Only] If the operation fails, this field contains the HTTP error status code that was returned. For example, a 404 means the resource was not found.

httpErrorMessage

string

[Output Only] If the operation fails, this field contains the HTTP error message that was returned, such as NOT FOUND.

region

string

[Output Only] The URL of the region where the operation resides. Only applicable when performing regional operations.

description

string

[Output Only] A textual description of the operation, which is set when the operation is created.

operationGroupId

string

[Output Only] An ID that represents a group of operations, such as when a group of operations results from a bulkInsert API request.

Authorization scopes

Requires one of the following OAuth scopes:

  • https://www.googleapis.com/auth/compute
  • https://www.googleapis.com/auth/cloud-platform

For more information, see the Authentication Overview.

IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following IAM permissions:

  • compute.instantSnapshots.export

To find predefined roles that contain those permissions, see Compute Engine IAM Roles.